`timescale 1ns / 1ps

module audio_buffer(r_addr, w_addr, r_clk, w_clk, din, we, out);
   input [7:0]   r_addr, w_addr;
   input         r_clk, w_clk;
   input [15:0]  din;
   input         we;
   output [15:0] out;

   reg [15:0]    RAM [255:0];
   reg [7:0]     read_addr;
   reg [7:0]     write_addr;
    
		
   always @(posedge w_clk)
     begin
       #1;
       if (we == 1'b1) begin
         RAM[write_addr] <= din;
       end

	 write_addr <= w_addr;
     end

   always @(posedge r_clk)
     begin
	 read_addr  <= r_addr;
     end
	  
   assign #(1) out = RAM[read_addr];

endmodule // audio_buffer

       