`timescale 1ns / 1ps

module audio_controller(
	SYSTEM_CLOCK,
	REG_SELECT,
	DATA_IN,
	WE,
	CLK,
	GWE,
	RST,
	READ_OUT,

	ac97_bit_clock,	// Generated by AC'97
	ac97_sdata_in,	// Serial data from AC'97

	ac97_sdata_out,	// Serial data to AC'97
	ac97_synch,		// Defines boundries of AC'97 frames, controls warm reset
	audio_reset_b	// AC'97 codec cold reset
);

input SYSTEM_CLOCK, WE, CLK, GWE, RST, ac97_bit_clock, ac97_sdata_in;
input [3:0] REG_SELECT;
input [15:0] DATA_IN;
output ac97_sdata_out, ac97_synch, audio_reset_b;
output [15:0] READ_OUT;

wire [19:0] left_in_data, right_in_data, left_out_data, right_out_data;
wire [15:0] READ_OUT;

// instantiate the clock generation module
CLOCK_GEN CLOCK_GEN (
	SYSTEM_CLOCK,
	system_clock_buffered,
	reset
);

// Audio module
audio audio0 (system_clock_buffered, reset, left_in_data, left_out_data, right_in_data, right_out_data, ready,
	      audio_reset_b, ac97_sdata_out, ac97_sdata_in,
         ac97_synch, ac97_bit_clock	  
			);

// Processing module: takes input, does something, sends output				  
processing processing0 (REG_SELECT, DATA_IN, WE, CLK, GWE, RST, ready, READ_OUT, left_out_data, right_out_data);


endmodule