`timescale 1ns / 1ps
`define MEMORY_IMAGE_FILE "boot_rom.hex"

// VERSION 1.1

module brom(addr, clk, dout);
   input [7:0]   addr;
   input         clk;
   output [15:0] dout;

   reg [15:0]    ROM [255:0];
   reg [7:0]     read_addr;
   
   integer       f;
   
   initial
     begin
        f = 0;
        // check that memory image exists
        f = $fopen( `MEMORY_IMAGE_FILE, "r" );
        if (f == 0) begin
           $display( "Memory image file: %s not found.", `MEMORY_IMAGE_FILE );
           $stop;
        end
        $fclose( f );
        // load memory image
        $readmemh(`MEMORY_IMAGE_FILE, ROM, 0, 255);
     end
   
   always @(posedge clk)
     begin
        #1;
        read_addr <= addr;
     end

   assign #(1) dout = ROM[read_addr];

endmodule // brom
