`timescale 1ns / 1ps

module cf_bram(addr, clk, din, dout, we);
   input [7:0]   addr;
   input         clk;
   input [15:0]  din;
   output [15:0] dout;
   input         we;

   reg [15:0]    RAM [256:0];
   reg [7:0]     read_addr;
	reg [7:0]	  write_addr;
      
	initial begin
     write_addr = 0;	
	end
		
   always @(posedge clk)
     begin
       #1;
       if (we == 1'b1) begin
         RAM[write_addr] <= din;
			write_addr = write_addr + 1;
       end
       read_addr <= addr;
     end
	  
   assign #(1) dout = RAM[read_addr];

endmodule // bram
